// SPDX-FileCopyrightText: 2024 Yury Gubich <blue@macaw.me>
// SPDX-License-Identifier: GPL-3.0-or-later

#pragma once

#include <string>
#include <iostream>
#include <vector>
#include <memory>
#include <functional>

#include <gloox/client.h>
#include <gloox/disco.h>
#include <gloox/connectionlistener.h>

#include "shared/definitions.h"
#include "component/core.h"
#include "component/loop.h"
#include "connection/connection.h"
#include "module/module.h"

class Jay {
public:
    Jay(const std::string& configPath);
    ~Jay();

    bool isConfigValid() const;

    void run();

private:
    void initialize();
    void createModules();

private:
    std::shared_ptr<Core> core;
    std::shared_ptr<Connection> connection;
    std::vector<std::shared_ptr<Module::Module>> modules;
    Loop loop;
    bool initialized;
};
